/*
Mike Morris and Karl Frinkle, Southeastern Oklahoma State University
Last Modified: 2011.11.14

This program will multiply two matrices A and B, and store their product in C.  The format that 
the files must be in is text, with one entry per line.  The program matrix_generator_ASCII_Linear
in the 00_MatrixCreation directory is the one to use for this program.  No arguments are needed
to execute this program, and the Makefile will compile this program correctly.

Note that this is a very simple program, with hard coded inputs.  However, this is a proof of 
concept for reading from files, and performing the right multiplication from once each matrix
has been read into memory.
*/


#include <stdlib.h>
#include <stdio.h>
#include <math.h>

	FILE *fpA, *fpB, *fpC;

int main()
{
	char line[80];
	float limit;
	int v;
	int j=0;
	int n = 9;
	int N = sqrt(n);
	int A[16], B[16], C[16];
	
	int c, r, s, k;

//	printf("%d\n",N);

	fpA = fopen("A9.txt", "r");

	while(fgets(line,80,fpA) != NULL){
		sscanf(line,"%d", &v);
//		printf("%d\n", v);
		A[j]=v;
		j++;
	}
	fclose(fpA);

	j=0;
	fpB = fopen("B9.txt", "r");

	while(fgets(line,80,fpB) != NULL){
		sscanf(line,"%d", &v);
		B[j]=v;
		j++;
	}
	fclose(fpB);

	
	for(k=0; k<n; k++){
		C[k]=0;
		c = fmod(k, N)+1;
		r = floor(k/N)+1;
		for(s=0; s<N; s++){
			C[k] = C[k]+A[s+(r-1)*N]*B[s*N+(c-1)];
// see if you can figure out where the above formula comes from!
		}
	}
		

	fpC = fopen("C9.txt", "w");

	for(j=0; j<n; j++)
		fprintf(fpC, "%d\n", C[j]);

	fclose(fpC);

	printf("\n\n");
}
