/*
Mike Morris and Karl Frinkle, Southeastern Oklahoma State Univesity
Last Modified: 2011.11.14

This program will generate an ASCII text file which contains a matrix in linear fashion, where the 
first sqrt(n) numbers will be the first row, the second sqrt(n) the second row, etc...  The program 
is hard coded to n=9, but this can be fixed by changing the variable "n" below to any perfect square.  
Upon completion of executing this program, you should have A9.txt and B9.txt in your working directory.
These are two 3x3 matrices.
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

	FILE *fpA, *fpB;

int main()
{
	char line[80];
	int j=0;
	int n = 9; //this should be a perfect square
	int seed = time(NULL);
	double temp;
	int rand1;
	int randval;

	srand(seed);
		
	fpA = fopen("A9.txt", "w");
	for(j=0; j<n; j++){
		rand1 = rand();
		temp = (double)rand1/(double)RAND_MAX;
		randval = -10+20*temp;
		fprintf(fpA, "%5d\n", randval);
	}
	fclose(fpA);

	fpB = fopen("B9.txt", "w");
	for(j=0; j<n; j++){
		rand1 = rand();
		temp = (double)rand1/(double)RAND_MAX;
		randval = 10*temp;
		fprintf(fpB, "%5d\n", randval);
	}
	fclose(fpB);
}
