/*
Mike Morris and Karl Frinkle, Southeastern Oklahoma State Universiry
Last Modified: 2011.11.14

This program will create the linear matrix text files, each line taking up 5 spaces.
This will allow the random access program MatrixMultRA to search throught the file
correctly, to locate each entry that it needs by a simply offset formula.

No arguments needed, the A9 and B9 .txt files are hard coded in.
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

	FILE *fpA, *fpB;

int main()
{
	char line[80];
	int j=0;
	int n = 9; //this should be a perfect square
	int seed = time(NULL);
	double temp;
	int rand1;
	int randval;

	srand(seed);
		
	fpA = fopen("A9.txt", "w");
	for(j=0; j<n; j++){
		rand1 = rand();
		temp = (double)rand1/(double)RAND_MAX;
		randval = -10+20*temp;
		fprintf(fpA, "%5d\n", randval);
	}
	fclose(fpA);

	fpB = fopen("B9.txt", "w");
	for(j=0; j<n; j++){
		rand1 = rand();
		temp = (double)rand1/(double)RAND_MAX;
		randval = 10*temp;
		fprintf(fpB, "%5d\n", randval);
	}
	fclose(fpB);
}
